<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents.html">capabilityAgents</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1external_media_player.html">externalMediaPlayer</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">ExternalMediaPlayer</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_external_media_player_8h_source.html">ExternalMediaPlayer.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_inherit__map" id="alexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html" title="alexaClientSDK::avsCommon\l::avs::CapabilityAgent" alt="" coords="304,125,501,164"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::DirectiveHandler\lInterface" alt="" coords="10,5,224,57"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::ChannelObserver\lInterface" alt="" coords="7,81,227,133"/>
<area shape="rect" id="node5" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::StateProvider\lInterface" alt="" coords="18,157,215,209"/>
<area shape="rect" id="node6" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::ContextRequester\lInterface" alt="" coords="5,233,228,285"/>
<area shape="rect" id="node7" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html" title="alexaClientSDK::avsCommon\l::utils::RequiresShutdown" alt="" coords="304,188,501,227"/>
<area shape="rect" id="node8" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::CapabilityConfiguration\lInterface" alt="" coords="276,251,530,303"/>
<area shape="rect" id="node9" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::ExternalMedia\lPlayerInterface" alt="" coords="303,327,503,379"/>
<area shape="rect" id="node10" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::PlaybackHandler\lInterface" alt="" coords="295,403,511,455"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_coll__map" id="alexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html" title="alexaClientSDK::avsCommon\l::avs::CapabilityAgent" alt="" coords="304,125,501,164"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::DirectiveHandler\lInterface" alt="" coords="10,5,224,57"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::ChannelObserver\lInterface" alt="" coords="7,81,227,133"/>
<area shape="rect" id="node5" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::StateProvider\lInterface" alt="" coords="18,157,215,209"/>
<area shape="rect" id="node6" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::ContextRequester\lInterface" alt="" coords="5,233,228,285"/>
<area shape="rect" id="node7" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html" title="alexaClientSDK::avsCommon\l::utils::RequiresShutdown" alt="" coords="304,188,501,227"/>
<area shape="rect" id="node8" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::CapabilityConfiguration\lInterface" alt="" coords="276,251,530,303"/>
<area shape="rect" id="node9" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::ExternalMedia\lPlayerInterface" alt="" coords="303,327,503,379"/>
<area shape="rect" id="node10" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::PlaybackHandler\lInterface" alt="" coords="295,403,511,455"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a28a66411b0781be1389740d150ffe63e"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a28a66411b0781be1389740d150ffe63e">AdapterMediaPlayerMap</a> = std::unordered_map&lt; std::string, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html">avsCommon::utils::mediaPlayer::MediaPlayerInterface</a> &gt; &gt;</td></tr>
<tr class="separator:a28a66411b0781be1389740d150ffe63e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe03eac517b773ae673e43014ee278cd"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afe03eac517b773ae673e43014ee278cd">AdapterSpeakerMap</a> = std::unordered_map&lt; std::string, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html">avsCommon::sdkInterfaces::SpeakerInterface</a> &gt; &gt;</td></tr>
<tr class="separator:afe03eac517b773ae673e43014ee278cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7c65b4b3001c18fcd5f36da44eb7aa3"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#af7c65b4b3001c18fcd5f36da44eb7aa3">AdapterCreateFunction</a> = std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_external_media_adapter_interface.html">avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaAdapterInterface</a> &gt;(*)(std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html">avsCommon::utils::mediaPlayer::MediaPlayerInterface</a> &gt; mediaPlayer, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html">avsCommon::sdkInterfaces::SpeakerInterface</a> &gt; speaker, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_manager_interface.html">avsCommon::sdkInterfaces::SpeakerManagerInterface</a> &gt; speakerManager, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_sender_interface.html">avsCommon::sdkInterfaces::MessageSenderInterface</a> &gt; messageSender, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html">avsCommon::sdkInterfaces::FocusManagerInterface</a> &gt; focusManager, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_manager_interface.html">avsCommon::sdkInterfaces::ContextManagerInterface</a> &gt; contextManager, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface.html">avsCommon::sdkInterfaces::ExternalMediaPlayerInterface</a> &gt; externalMediaPlayer)</td></tr>
<tr class="separator:af7c65b4b3001c18fcd5f36da44eb7aa3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf4ebe27e2dfdda96617f1f0c2667e1c"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#aaf4ebe27e2dfdda96617f1f0c2667e1c">AdapterCreationMap</a> = std::unordered_map&lt; std::string, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#af7c65b4b3001c18fcd5f36da44eb7aa3">AdapterCreateFunction</a> &gt;</td></tr>
<tr class="separator:aaf4ebe27e2dfdda96617f1f0c2667e1c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a6d108b677d7fe0ce3cad66c908159d4d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a6d108b677d7fe0ce3cad66c908159d4d">addObserver</a> (const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_external_media_player_observer_interface.html">avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaPlayerObserverInterface</a> &gt; observer)</td></tr>
<tr class="separator:a6d108b677d7fe0ce3cad66c908159d4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd79af71fe1ee4798a23bb91ba172281"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afd79af71fe1ee4798a23bb91ba172281">removeObserver</a> (const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_external_media_player_observer_interface.html">avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaPlayerObserverInterface</a> &gt; observer)</td></tr>
<tr class="separator:afd79af71fe1ee4798a23bb91ba172281"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">StateProviderInterface Functions</div></td></tr>
<tr class="memitem:a411c285401048584df6a15b673925b34"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a411c285401048584df6a15b673925b34">provideState</a> (const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a> &amp;stateProviderName, unsigned int stateRequestToken) override</td></tr>
<tr class="separator:a411c285401048584df6a15b673925b34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">CapabilityAgent/DirectiveHandlerInterface Functions</div></td></tr>
<tr class="memitem:a8c183a7206e3a414f01d281463399da0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a8c183a7206e3a414f01d281463399da0">handleDirectiveImmediately</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; directive) override</td></tr>
<tr class="separator:a8c183a7206e3a414f01d281463399da0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a155ab4a13a22cef56d02f7e53310dd46"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a155ab4a13a22cef56d02f7e53310dd46">preHandleDirective</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">DirectiveInfo</a> &gt; info) override</td></tr>
<tr class="separator:a155ab4a13a22cef56d02f7e53310dd46"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a534f82df0aa77595bef7622ac1df5b47"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a534f82df0aa77595bef7622ac1df5b47">handleDirective</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">DirectiveInfo</a> &gt; info) override</td></tr>
<tr class="separator:a534f82df0aa77595bef7622ac1df5b47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a072925a5404ec4192b08fc27a7fcd1a7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a072925a5404ec4192b08fc27a7fcd1a7">cancelDirective</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">DirectiveInfo</a> &gt; info) override</td></tr>
<tr class="separator:a072925a5404ec4192b08fc27a7fcd1a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a00630efe454bba50a562505eb1457038"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a00630efe454bba50a562505eb1457038">onDeregistered</a> () override</td></tr>
<tr class="separator:a00630efe454bba50a562505eb1457038"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae6c3e74940d288662ca3c28273b1e297"><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">avsCommon::avs::DirectiveHandlerConfiguration</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#ae6c3e74940d288662ca3c28273b1e297">getConfiguration</a> () const override</td></tr>
<tr class="separator:ae6c3e74940d288662ca3c28273b1e297"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">Overridden PlaybackHandlerInterface methods.</div></td></tr>
<tr class="memitem:a5470f248f826e7b37f49289bd06e6fc6"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a5470f248f826e7b37f49289bd06e6fc6">onButtonPressed</a> (<a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a61e425aaa1522eafa6647f6b11cb9556">avsCommon::avs::PlaybackButton</a> button) override</td></tr>
<tr class="separator:a5470f248f826e7b37f49289bd06e6fc6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a308cb9cc7b6752ffa28a4c8541b725dc"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a308cb9cc7b6752ffa28a4c8541b725dc">onTogglePressed</a> (<a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ad9f7d4000e3b111db271f73d9e34604b">avsCommon::avs::PlaybackToggle</a> toggle, bool action) override</td></tr>
<tr class="separator:a308cb9cc7b6752ffa28a4c8541b725dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">Overridden ExternalMediaPlayerInterface methods.</div></td></tr>
<tr class="memitem:a5f5857024eae187fda8e18176f7f4e63"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a5f5857024eae187fda8e18176f7f4e63">setPlayerInFocus</a> (const std::string &amp;playerInFocus) override</td></tr>
<tr class="separator:a5f5857024eae187fda8e18176f7f4e63"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">CapabilityConfigurationInterface Functions</div></td></tr>
<tr class="memitem:a83b830e98e907125e1c211aa0e29e7f1"><td class="memItemLeft" align="right" valign="top">std::unordered_set&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_configuration.html">avsCommon::avs::CapabilityConfiguration</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a83b830e98e907125e1c211aa0e29e7f1">getCapabilityConfigurations</a> () override</td></tr>
<tr class="separator:a83b830e98e907125e1c211aa0e29e7f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html">alexaClientSDK::avsCommon::avs::CapabilityAgent</a></td></tr>
<tr class="memitem:ab6745fae4f7b144f64d34251c76d14f7 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ab6745fae4f7b144f64d34251c76d14f7">~CapabilityAgent</a> ()=default</td></tr>
<tr class="separator:ab6745fae4f7b144f64d34251c76d14f7 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6643447cdbecc1e49e14532b0cc83cf1 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a6643447cdbecc1e49e14532b0cc83cf1">preHandleDirective</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a> &gt; directive, std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface.html">sdkInterfaces::DirectiveHandlerResultInterface</a> &gt; result) override final</td></tr>
<tr class="separator:a6643447cdbecc1e49e14532b0cc83cf1 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a971352c6a79f7cb000e5e632648bceb3 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a971352c6a79f7cb000e5e632648bceb3">handleDirective</a> (const std::string &amp;messageId) override final</td></tr>
<tr class="separator:a971352c6a79f7cb000e5e632648bceb3 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3840603cf5c461f2e13b61cbab0e3e90 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a3840603cf5c461f2e13b61cbab0e3e90">cancelDirective</a> (const std::string &amp;messageId) override final</td></tr>
<tr class="separator:a3840603cf5c461f2e13b61cbab0e3e90 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab63458984e8abac5b7fd8df22149cf9b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ab63458984e8abac5b7fd8df22149cf9b">onFocusChanged</a> (<a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a066217aef6bc1e0e18dd3a13f467d275">FocusState</a> newFocus) override</td></tr>
<tr class="separator:ab63458984e8abac5b7fd8df22149cf9b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2ad8b4b2bbcf6070e2b6e9e13785322 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#aa2ad8b4b2bbcf6070e2b6e9e13785322">onContextAvailable</a> (const std::string &amp;jsonContext) override</td></tr>
<tr class="separator:aa2ad8b4b2bbcf6070e2b6e9e13785322 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8f0c021b6eca42f22d5e0afe33cffdc inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ae8f0c021b6eca42f22d5e0afe33cffdc">onContextFailure</a> (const <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html#a8ec2f2403294717c740bfacf5c62d018">sdkInterfaces::ContextRequestError</a> error) override</td></tr>
<tr class="separator:ae8f0c021b6eca42f22d5e0afe33cffdc inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface</a></td></tr>
<tr class="memitem:a0aa03b6867e8b6e44b8c1b8df93c2d5c inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a0aa03b6867e8b6e44b8c1b8df93c2d5c">~DirectiveHandlerInterface</a> ()=default</td></tr>
<tr class="separator:a0aa03b6867e8b6e44b8c1b8df93c2d5c inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a517f1f6ceeba26da9dd071b9ad3dc390 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a517f1f6ceeba26da9dd071b9ad3dc390">handleDirectiveImmediately</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; directive)=0</td></tr>
<tr class="separator:a517f1f6ceeba26da9dd071b9ad3dc390 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9bfec681151c104a12274fde87ff507d inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a9bfec681151c104a12274fde87ff507d">preHandleDirective</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; directive, std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface.html">DirectiveHandlerResultInterface</a> &gt; result)=0</td></tr>
<tr class="separator:a9bfec681151c104a12274fde87ff507d inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ChannelObserverInterface</a></td></tr>
<tr class="memitem:a451bc071c57df259d0a3c801926aba4b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface.html#a451bc071c57df259d0a3c801926aba4b">~ChannelObserverInterface</a> ()=default</td></tr>
<tr class="separator:a451bc071c57df259d0a3c801926aba4b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::StateProviderInterface</a></td></tr>
<tr class="memitem:a005d5be73f5a0b6d3306e37fb324249f inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface.html#a005d5be73f5a0b6d3306e37fb324249f">~StateProviderInterface</a> ()=default</td></tr>
<tr class="separator:a005d5be73f5a0b6d3306e37fb324249f inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ContextRequesterInterface</a></td></tr>
<tr class="memitem:a761877550e7024ecd44aea4ca306b877 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface.html#a761877550e7024ecd44aea4ca306b877">~ContextRequesterInterface</a> ()=default</td></tr>
<tr class="separator:a761877550e7024ecd44aea4ca306b877 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">alexaClientSDK::avsCommon::utils::RequiresShutdown</a></td></tr>
<tr class="memitem:aae7174ed932ae1413460255238c4422b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#aae7174ed932ae1413460255238c4422b">RequiresShutdown</a> (const std::string &amp;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a>)</td></tr>
<tr class="separator:aae7174ed932ae1413460255238c4422b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a649b80d77e4e6f66e218ee3bfc71823b">~RequiresShutdown</a> ()</td></tr>
<tr class="memdesc:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a649b80d77e4e6f66e218ee3bfc71823b">More...</a><br /></td></tr>
<tr class="separator:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a745cd4dc404db52f7d0afbf838454fac inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a> () const</td></tr>
<tr class="separator:a745cd4dc404db52f7d0afbf838454fac inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a350a147e52eb3ad3c1326e6639861066 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown</a> ()</td></tr>
<tr class="separator:a350a147e52eb3ad3c1326e6639861066 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9352626109735aba40b5fb310913355 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#af9352626109735aba40b5fb310913355">isShutdown</a> () const</td></tr>
<tr class="separator:af9352626109735aba40b5fb310913355 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::CapabilityConfigurationInterface</a></td></tr>
<tr class="memitem:ac5cec30da8c9039ec5eea44b82f018eb inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html#ac5cec30da8c9039ec5eea44b82f018eb">~CapabilityConfigurationInterface</a> ()=default</td></tr>
<tr class="separator:ac5cec30da8c9039ec5eea44b82f018eb inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ExternalMediaPlayerInterface</a></td></tr>
<tr class="memitem:a48c76ab3d8d3cbcc7af5ad2e0268a202 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface.html#a48c76ab3d8d3cbcc7af5ad2e0268a202">~ExternalMediaPlayerInterface</a> ()=default</td></tr>
<tr class="separator:a48c76ab3d8d3cbcc7af5ad2e0268a202 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::PlaybackHandlerInterface</a></td></tr>
<tr class="memitem:aaede62471b1dc9d2338e61acc4d5196f inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface.html#aaede62471b1dc9d2338e61acc4d5196f">~PlaybackHandlerInterface</a> ()=default</td></tr>
<tr class="separator:aaede62471b1dc9d2338e61acc4d5196f inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ad2500c46956304f9eb323f009d85f957"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">ExternalMediaPlayer</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#ad2500c46956304f9eb323f009d85f957">create</a> (const <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a28a66411b0781be1389740d150ffe63e">AdapterMediaPlayerMap</a> &amp;mediaPlayers, const <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afe03eac517b773ae673e43014ee278cd">AdapterSpeakerMap</a> &amp;speakers, const <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#aaf4ebe27e2dfdda96617f1f0c2667e1c">AdapterCreationMap</a> &amp;adapterCreationMap, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_manager_interface.html">avsCommon::sdkInterfaces::SpeakerManagerInterface</a> &gt; speakerManager, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_sender_interface.html">avsCommon::sdkInterfaces::MessageSenderInterface</a> &gt; messageSender, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html">avsCommon::sdkInterfaces::FocusManagerInterface</a> &gt; focusManager, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_manager_interface.html">avsCommon::sdkInterfaces::ContextManagerInterface</a> &gt; contextManager, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html">avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface</a> &gt; exceptionSender, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_router_interface.html">avsCommon::sdkInterfaces::PlaybackRouterInterface</a> &gt; playbackRouter)</td></tr>
<tr class="separator:ad2500c46956304f9eb323f009d85f957"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html">alexaClientSDK::avsCommon::avs::CapabilityAgent</a></td></tr>
<tr class="memitem:a7254a7c71bc99bdeab87ae9a2c7dc5c8 inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a7254a7c71bc99bdeab87ae9a2c7dc5c8">CapabilityAgent</a> (const std::string &amp;nameSpace, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html">sdkInterfaces::ExceptionEncounteredSenderInterface</a> &gt; exceptionEncounteredSender)</td></tr>
<tr class="separator:a7254a7c71bc99bdeab87ae9a2c7dc5c8 inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a19f623357462b3e1a0b2f9c55743198b inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">virtual std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">DirectiveInfo</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a19f623357462b3e1a0b2f9c55743198b">createDirectiveInfo</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a> &gt; directive, std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface.html">sdkInterfaces::DirectiveHandlerResultInterface</a> &gt; result)</td></tr>
<tr class="separator:a19f623357462b3e1a0b2f9c55743198b inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8818d802b24e4b2a69ddeac9c659199f inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a8818d802b24e4b2a69ddeac9c659199f">removeDirective</a> (const std::string &amp;messageId)</td></tr>
<tr class="separator:a8818d802b24e4b2a69ddeac9c659199f inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2c522e09b9b367e75cf7f09a548f7bfe inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a2c522e09b9b367e75cf7f09a548f7bfe">sendExceptionEncounteredAndReportFailed</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">DirectiveInfo</a> &gt; info, const std::string &amp;message, <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fc">avsCommon::avs::ExceptionErrorType</a> type=<a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fcae8c0c70879b5895c615677261d64a1ee">avsCommon::avs::ExceptionErrorType::INTERNAL_ERROR</a>)</td></tr>
<tr class="separator:a2c522e09b9b367e75cf7f09a548f7bfe inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0141d9d834ebc600e75117d5fc791202 inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">const std::pair&lt; std::string, std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a0141d9d834ebc600e75117d5fc791202">buildJsonEventString</a> (const std::string &amp;eventName, const std::string &amp;dialogRequestIdString=&quot;&quot;, const std::string &amp;payload=&quot;{}&quot;, const std::string &amp;context=&quot;&quot;)</td></tr>
<tr class="separator:a0141d9d834ebc600e75117d5fc791202 inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html">alexaClientSDK::avsCommon::avs::CapabilityAgent</a></td></tr>
<tr class="memitem:a44fd59779e935c0548b4ec2938ee364b inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a44fd59779e935c0548b4ec2938ee364b">m_namespace</a></td></tr>
<tr class="memdesc:a44fd59779e935c0548b4ec2938ee364b inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="mdescLeft">&#160;</td><td class="mdescRight">The namespace of the capability agent.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a44fd59779e935c0548b4ec2938ee364b">More...</a><br /></td></tr>
<tr class="separator:a44fd59779e935c0548b4ec2938ee364b inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac15d9611ab7ae14824cdf5fc52d79dc5 inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memItemLeft" align="right" valign="top">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html">sdkInterfaces::ExceptionEncounteredSenderInterface</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ac15d9611ab7ae14824cdf5fc52d79dc5">m_exceptionEncounteredSender</a></td></tr>
<tr class="memdesc:ac15d9611ab7ae14824cdf5fc52d79dc5 inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="mdescLeft">&#160;</td><td class="mdescRight">Object to use to send exceptionEncountered messages.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ac15d9611ab7ae14824cdf5fc52d79dc5">More...</a><br /></td></tr>
<tr class="separator:ac15d9611ab7ae14824cdf5fc52d79dc5 inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">This class implements the <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">ExternalMediaPlayer</a></code> capability agent. This agent is responsible for handling music service providers which manage their PLAY queue.</p>
<dl class="section note"><dt>Note</dt><dd>For instances of this class to be cleaned up correctly, <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown()</a></code> must be called. </dd></dl>
</div><h2 class="groupheader">Member Typedef Documentation</h2>
<a id="af7c65b4b3001c18fcd5f36da44eb7aa3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af7c65b4b3001c18fcd5f36da44eb7aa3">&#9670;&nbsp;</a></span>AdapterCreateFunction</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#af7c65b4b3001c18fcd5f36da44eb7aa3">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::AdapterCreateFunction</a> =  std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_external_media_adapter_interface.html">avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaAdapterInterface</a>&gt; (*)( std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html">avsCommon::utils::mediaPlayer::MediaPlayerInterface</a>&gt; mediaPlayer, std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html">avsCommon::sdkInterfaces::SpeakerInterface</a>&gt; speaker, std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_manager_interface.html">avsCommon::sdkInterfaces::SpeakerManagerInterface</a>&gt; speakerManager, std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_sender_interface.html">avsCommon::sdkInterfaces::MessageSenderInterface</a>&gt; messageSender, std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html">avsCommon::sdkInterfaces::FocusManagerInterface</a>&gt; focusManager, std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_manager_interface.html">avsCommon::sdkInterfaces::ContextManagerInterface</a>&gt; contextManager, std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface.html">avsCommon::sdkInterfaces::ExternalMediaPlayerInterface</a>&gt; externalMediaPlayer)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="aaf4ebe27e2dfdda96617f1f0c2667e1c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaf4ebe27e2dfdda96617f1f0c2667e1c">&#9670;&nbsp;</a></span>AdapterCreationMap</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#aaf4ebe27e2dfdda96617f1f0c2667e1c">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::AdapterCreationMap</a> =  std::unordered_map&lt;std::string, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#af7c65b4b3001c18fcd5f36da44eb7aa3">AdapterCreateFunction</a>&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a28a66411b0781be1389740d150ffe63e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a28a66411b0781be1389740d150ffe63e">&#9670;&nbsp;</a></span>AdapterMediaPlayerMap</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a28a66411b0781be1389740d150ffe63e">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::AdapterMediaPlayerMap</a> =  std::unordered_map&lt;std::string, std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html">avsCommon::utils::mediaPlayer::MediaPlayerInterface</a>&gt; &gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="afe03eac517b773ae673e43014ee278cd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afe03eac517b773ae673e43014ee278cd">&#9670;&nbsp;</a></span>AdapterSpeakerMap</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afe03eac517b773ae673e43014ee278cd">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::AdapterSpeakerMap</a> =  std::unordered_map&lt;std::string, std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html">avsCommon::sdkInterfaces::SpeakerInterface</a>&gt; &gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a6d108b677d7fe0ce3cad66c908159d4d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6d108b677d7fe0ce3cad66c908159d4d">&#9670;&nbsp;</a></span>addObserver()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::addObserver </td>
          <td>(</td>
          <td class="paramtype">const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_external_media_player_observer_interface.html">avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaPlayerObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Adds an observer which will be notified on any observable state changes</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to add </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a072925a5404ec4192b08fc27a7fcd1a7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a072925a5404ec4192b08fc27a7fcd1a7">&#9670;&nbsp;</a></span>cancelDirective()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::cancelDirective </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">DirectiveInfo</a> &gt;&#160;</td>
          <td class="paramname"><em>info</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Cancel an ongoing <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a155ab4a13a22cef56d02f7e53310dd46">preHandleDirective()</a></code> or <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a534f82df0aa77595bef7622ac1df5b47">handleDirective()</a></code> operation for the <code>AVSDirective</code> in . Once this has been called the <code>CapabilityAgent</code> should not expect to receive further calls regarding this directive.</p>
<dl class="section note"><dt>Note</dt><dd>The implementation of this method MUST be thread-safe. </dd>
<dd>
The implementation of this method MUST return quickly. Failure to do so blocks the processing of subsequent <code>AVSDirectives</code>.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">info</td><td>The <code>DirectiveInfo</code> instance for the <code>AVSDirective</code> to process. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a35414897b8abb3a2ee72bde01b897e04">alexaClientSDK::avsCommon::avs::CapabilityAgent</a>.</p>

</div>
</div>
<a id="ad2500c46956304f9eb323f009d85f957"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad2500c46956304f9eb323f009d85f957">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">ExternalMediaPlayer</a> &gt; alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::create </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a28a66411b0781be1389740d150ffe63e">AdapterMediaPlayerMap</a> &amp;&#160;</td>
          <td class="paramname"><em>mediaPlayers</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afe03eac517b773ae673e43014ee278cd">AdapterSpeakerMap</a> &amp;&#160;</td>
          <td class="paramname"><em>speakers</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#aaf4ebe27e2dfdda96617f1f0c2667e1c">AdapterCreationMap</a> &amp;&#160;</td>
          <td class="paramname"><em>adapterCreationMap</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_manager_interface.html">avsCommon::sdkInterfaces::SpeakerManagerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>speakerManager</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_sender_interface.html">avsCommon::sdkInterfaces::MessageSenderInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>messageSender</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_focus_manager_interface.html">avsCommon::sdkInterfaces::FocusManagerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>focusManager</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_manager_interface.html">avsCommon::sdkInterfaces::ContextManagerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>contextManager</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html">avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>exceptionSender</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_router_interface.html">avsCommon::sdkInterfaces::PlaybackRouterInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>playbackRouter</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates a new <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">ExternalMediaPlayer</a></code> instance.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">mediaPlayers</td><td>The map of &lt;PlayerId, MediaPlayer&gt; to be used to find the <a class="el" href="namespacealexa_client_s_d_k_1_1media_player.html">mediaPlayer</a> to use for this adapter. </td></tr>
    <tr><td class="paramname">speakers</td><td>The map of &lt;PlayerId, SpeakerInterface&gt; to be used to find the speaker to use for this adapter. </td></tr>
    <tr><td class="paramname">adapterCreationMap</td><td>The map of &lt;PlayerId, AdapterCreateFunction&gt; to be used to create the adapters. </td></tr>
    <tr><td class="paramname"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1speaker_manager.html">speakerManager</a></td><td>A <code>SpeakerManagerInterface</code> to perform volume changes requested by adapters. </td></tr>
    <tr><td class="paramname">messageSender</td><td>The object to use for sending events. </td></tr>
    <tr><td class="paramname">focusManager</td><td>The object used to manage focus for the adapter managed by the EMP. </td></tr>
    <tr><td class="paramname"><a class="el" href="namespacealexa_client_s_d_k_1_1context_manager.html">contextManager</a></td><td>The AVS Context manager used to generate system context for events. </td></tr>
    <tr><td class="paramname">exceptionSender</td><td>The object to use for sending AVS Exception messages. </td></tr>
    <tr><td class="paramname">playbackRouter</td><td>The <code>PlaybackRouterInterface</code> instance to use when <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">ExternalMediaPlayer</a></code> becomes active. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A <code>std::shared_ptr</code> to the new <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">ExternalMediaPlayer</a></code> instance. </dd></dl>

</div>
</div>
<a id="a83b830e98e907125e1c211aa0e29e7f1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a83b830e98e907125e1c211aa0e29e7f1">&#9670;&nbsp;</a></span>getCapabilityConfigurations()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unordered_set&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_configuration.html">avsCommon::avs::CapabilityConfiguration</a> &gt; &gt; alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::getCapabilityConfigurations </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Returns the configurations of the capability interfaces being implemented.</p>
<dl class="section return"><dt>Returns</dt><dd>A set of CapabilityConfigurations </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html#a1d4d5be614325de11563b2375fbb651c">alexaClientSDK::avsCommon::sdkInterfaces::CapabilityConfigurationInterface</a>.</p>

</div>
</div>
<a id="ae6c3e74940d288662ca3c28273b1e297"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae6c3e74940d288662ca3c28273b1e297">&#9670;&nbsp;</a></span>getConfiguration()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">DirectiveHandlerConfiguration</a> alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::getConfiguration </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Returns the configuration of the directive handler regarding which namespace and name pairs it should handle and the appropriate policy for each pair.</p>
<dl class="section return"><dt>Returns</dt><dd>The <code>avs::DirectiveHandlerConfiguration</code> of the handler. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a9a4151577d823b1e991af340c233441b">alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface</a>.</p>

</div>
</div>
<a id="a534f82df0aa77595bef7622ac1df5b47"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a534f82df0aa77595bef7622ac1df5b47">&#9670;&nbsp;</a></span>handleDirective()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::handleDirective </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">DirectiveInfo</a> &gt;&#160;</td>
          <td class="paramname"><em>info</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Handle the action specified by the <code>AVSDirective</code> in <code>info</code>. The handling of subsequent directives with the same <code>DialogRequestId</code> may be blocked until the <code>DirectiveHandler</code> calls the <code>setSucceeded()</code> method of the <code>DirectiveHandlingResult</code> present in <code>info</code>. If handling of this directive fails <code>setFailed()</code> should be called to indicate a failure.</p>
<dl class="section note"><dt>Note</dt><dd>The implementation of this method MUST be thread-safe. </dd>
<dd>
The implementation of this method MUST return quickly. Failure to do so blocks the processing of subsequent <code>AVSDirectives</code>.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">info</td><td>The <code>DirectiveInfo</code> instance for the <code>AVSDirective</code> to process. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a3f8616a9e8e0f99e1805d8bdf9349977">alexaClientSDK::avsCommon::avs::CapabilityAgent</a>.</p>

</div>
</div>
<a id="a8c183a7206e3a414f01d281463399da0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8c183a7206e3a414f01d281463399da0">&#9670;&nbsp;</a></span>handleDirectiveImmediately()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::handleDirectiveImmediately </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt;&#160;</td>
          <td class="paramname"><em>directive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a5470f248f826e7b37f49289bd06e6fc6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5470f248f826e7b37f49289bd06e6fc6">&#9670;&nbsp;</a></span>onButtonPressed()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::onButtonPressed </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a61e425aaa1522eafa6647f6b11cb9556">avsCommon::avs::PlaybackButton</a>&#160;</td>
          <td class="paramname"><em>button</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Used to notify the handler when a playback button is pressed.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">button</td><td>The button that has been pressed. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface.html#a2cf606bf26f4583051487617d92dafda">alexaClientSDK::avsCommon::sdkInterfaces::PlaybackHandlerInterface</a>.</p>

</div>
</div>
<a id="a00630efe454bba50a562505eb1457038"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a00630efe454bba50a562505eb1457038">&#9670;&nbsp;</a></span>onDeregistered()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::onDeregistered </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Notification that this handler has been de-registered and will not receive any more calls. </p>

<p>Reimplemented from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a534b6a5c2280f9fcd0866a82524bbca4">alexaClientSDK::avsCommon::avs::CapabilityAgent</a>.</p>

</div>
</div>
<a id="a308cb9cc7b6752ffa28a4c8541b725dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a308cb9cc7b6752ffa28a4c8541b725dc">&#9670;&nbsp;</a></span>onTogglePressed()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::onTogglePressed </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ad9f7d4000e3b111db271f73d9e34604b">avsCommon::avs::PlaybackToggle</a>&#160;</td>
          <td class="paramname"><em>toggle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>action</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Used to notify the handler when a playback toggle is pressed.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">toggle</td><td>The toggle that has been pressed. </td></tr>
    <tr><td class="paramname">action</td><td>The boolean action for the toggle state </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface.html#a5601040fe54745e6443aeccb44f310da">alexaClientSDK::avsCommon::sdkInterfaces::PlaybackHandlerInterface</a>.</p>

</div>
</div>
<a id="a155ab4a13a22cef56d02f7e53310dd46"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a155ab4a13a22cef56d02f7e53310dd46">&#9670;&nbsp;</a></span>preHandleDirective()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::preHandleDirective </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">DirectiveInfo</a> &gt;&#160;</td>
          <td class="paramname"><em>info</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Notification that a directive has arrived. This notification gives the DirectiveHandler a chance to prepare for handling of an <code>AVSDirective</code>. If an error occurs during the pre-Handling phase and that error should cancel the handling of subsequent <code>AVSDirectives</code> with the same <code>DialogRequestId</code>, the <code>DirectiveHandler</code> should call the <code>setFailed</code> method on the <code>result</code> instance passed in to this call.</p>
<dl class="section note"><dt>Note</dt><dd>The implementation of this method MUST be thread-safe. </dd>
<dd>
The implementation of this method MUST return quickly. Failure to do so blocks the processing of subsequent <code>AVSDirectives</code>.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">info</td><td>The <code>DirectiveInfo</code> instance for the <code>AVSDirective</code> to process. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a2c1af56e9bc7728dd0e0918db81fc0be">alexaClientSDK::avsCommon::avs::CapabilityAgent</a>.</p>

</div>
</div>
<a id="a411c285401048584df6a15b673925b34"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a411c285401048584df6a15b673925b34">&#9670;&nbsp;</a></span>provideState()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::provideState </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a> &amp;&#160;</td>
          <td class="paramname"><em>stateProviderName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>stateRequestToken</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">A request to a <code>StateProvider</code> to provide the state. The <code>StateProvider</code> should perform minimum processing and return quickly, otherwise it will block the processing of updating the states of other <code>StateProviders</code>. The <code>ContextManager</code> specifies a token which it uses to track the <code>getContext</code> request associated with this <code>provideState</code> request. The <code>stateProviderInterface</code> must use the same token when it updates its state via the <code>setState</code> call.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">stateProviderName</td><td>The name of the state provider. </td></tr>
    <tr><td class="paramname">stateRequestToken</td><td>The token to use in the <code>setState</code> call. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#af056b26452e6c4ca5855a72ec2bfcde4">alexaClientSDK::avsCommon::avs::CapabilityAgent</a>.</p>

</div>
</div>
<a id="afd79af71fe1ee4798a23bb91ba172281"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afd79af71fe1ee4798a23bb91ba172281">&#9670;&nbsp;</a></span>removeObserver()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::removeObserver </td>
          <td>(</td>
          <td class="paramtype">const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_external_media_player_observer_interface.html">avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaPlayerObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Removes an observer from the list of active watchers</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to remove </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a5f5857024eae187fda8e18176f7f4e63"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5f5857024eae187fda8e18176f7f4e63">&#9670;&nbsp;</a></span>setPlayerInFocus()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::setPlayerInFocus </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>playerInFocus</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Method to set the player in focus after an adapter has acquired the channel.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">playerInFocus</td><td>The business name of the adapter that has currently acquired focus. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface.html#a7f95bbd4835965742a6431aaee23b7e4">alexaClientSDK::avsCommon::sdkInterfaces::ExternalMediaPlayerInterface</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/CapabilityAgents/ExternalMediaPlayer/include/ExternalMediaPlayer/<a class="el" href="_external_media_player_8h_source.html">ExternalMediaPlayer.h</a></li>
<li>/workplace/avs-device-sdk/CapabilityAgents/ExternalMediaPlayer/src/<a class="el" href="_external_media_player_8cpp.html">ExternalMediaPlayer.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
